/*
 * COSMA -- A Virtual Machine for the Secure Cooperation of Untrusted Components.
 * Copyright (C) 2019  Roland Wismüller and Damian Ludwig, University of Siegen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package cola.ast;

public class DebugInfo {
    private final int lineNumber;
    private final int columnNumber;
    private final String lineImage;
    private final String fileName;

    public DebugInfo(int lin, int col, String limage, String fname) {
        lineNumber = lin;
        columnNumber = col;
        lineImage = limage;
        fileName = fname;
    }

    public String toString() {
        return String.format("In file %s at line %d:%d\n%s",
                             fileName,
                             lineNumber,
                             columnNumber,
                             lineImage);
    }
}
