/* Generated By:JavaCC: Do not edit this line. Cola.java */
    package cola.parser;

import java.io.*;
import java.util.*;
import cola.ast.*;
import cola.ast.exp.*;
import cola.ast.stm.*;
import cola.ast.type.*;
import cola.util.FileUtils;
import cosma.tools.logger.Logger;
import cosma.tools.logger.LogManager;

public final class Cola implements ColaConstants {
    private static Logger logger = LogManager.getCurrentClassLogger();
    public static ComponentNode parseFromFile(String filename) {
           try {
               String code = FileUtils.read(filename);
               return Cola.parseFromString(code, filename);
           } catch (IOException e) {
               logger.error("Something went from while reading {file}", filename);
               e.printStackTrace();
               System.exit(1);
           }
           return null;
    }
    private static ComponentNode parseFromString(String input, String filename) {
        Cola p = new Cola(input);
        p.currentFileName = filename;
        try {
            return p.ComponentNode();
        } catch (ParseException e) {
            Token t = e.currentToken;
            int linum = t.next.beginLine;
            int colnum = t.next.beginColumn;

            logger.error("Syntax error in " +
                         p.currentFileName +
                         " at line " +
                         linum + "," + (colnum) +
                         ":");

            String line = p.getLine(linum-1);
            if (line != null) {
                System.out.println(line);
                String errorPointer = "^";
                for (int i=0;i<colnum-1;i++)
                    errorPointer = "_" + errorPointer;
                System.out.println(errorPointer);
            }

            System.out.println();

            String errorMessage = getEncountered(t, e.tokenImage) +
                getExpected(e.expectedTokenSequences, e.tokenImage);
            System.out.println(errorMessage);

            System.exit(1);
        }
        return null;
    }

    private String getLine(int linum) {
        if (lineImages.size() > linum)
            return lineImages.get(linum);
        return null;
    }

    private static List<String> splitLine(String text) {
        List<String> lines = new ArrayList<String>();
        BufferedReader reader = new BufferedReader(new StringReader(text));
        try {
            String line = reader.readLine();
            while (line != null) {
                lines.add(line);
                line = reader.readLine();
            }
        } catch (IOException exc) {
            // quit
        }
        return lines;
    }

    private static String getEncountered(Token currentToken,
                                         String[] tokenImage) {
        String retval = "Found ";
        Token tok = currentToken.next;
        if (tok.kind == 0) {
            retval += tokenImage[0];
            return retval;
        }
        retval += "\u005c"";
        retval += tok.image;
        retval += "\u005c"\u005cn";

        return retval;
    }

    private static String getExpected(int[][] expectedTokenSequences,
                                      String[] tokenImage) {
        String retval = "";
        String EOL = "\u005cn";
        StringBuffer expected = new StringBuffer();
        int maxSize = 0;
        for (int i = 0; i < expectedTokenSequences.length; i++) {
            if (maxSize < expectedTokenSequences[i].length) {
                maxSize = expectedTokenSequences[i].length;
            }
            for (int j = 0; j < expectedTokenSequences[i].length; j++) {
                expected.append(tokenImage[expectedTokenSequences[i][j]]).append(' ');
            }
            if (expectedTokenSequences[i][expectedTokenSequences[i].length - 1] != 0) {
                expected.append("...");
            }
            expected.append(EOL).append("                ");
        }

        if (expectedTokenSequences.length == 0) {
            // Nothing to add here
        } else {
            if (expectedTokenSequences.length == 1) {
                retval += "Was expecting:" + EOL + "            ";
            } else {
                retval += "Was expecting one of:" + EOL + "              ";
            }
            retval += expected.toString();
        }

        return retval;
    }

    public Cola(String input) {
        this(new StringReader(input));
        lineImages = splitLine(input);
    }

    public <A> List<A> add(List<A> list, A item) {
        if (list == null)
            list = new ArrayList<A>();
        list.add(item);
        return list;
    }

    public DebugInfo makeDbgInfo(Token t) {
        return new DebugInfo(t.beginLine,
                             t.beginColumn, getLine(t.beginLine-1),
                             currentFileName);
    }

    public String currentFileName;
    private List<String> lineImages;

/* Grammar definitions */
  final public ModifierNode AccessModifierNode() throws ParseException {
        ModifierNode mod = ModifierNode.PUBLIC;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PUBLIC:
    case PROTECTED:
    case PRIVATE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PUBLIC:
        jj_consume_token(PUBLIC);
                   mod = ModifierNode.PUBLIC;
        break;
      case PRIVATE:
        jj_consume_token(PRIVATE);
                    mod = ModifierNode.PRIVATE;
        break;
      case PROTECTED:
        jj_consume_token(PROTECTED);
                      mod = ModifierNode.PROTECTED;
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
          {if (true) return mod;}
    throw new Error("Missing return statement in function");
  }

  final public Set<String> Dependencies() throws ParseException {
        Set<String> dependencies = new HashSet<String>();
        String libId;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPORT:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_1;
      }
      jj_consume_token(IMPORT);
      libId = FQN();
      jj_consume_token(SEMICOLON);
                                       dependencies.add(libId);
    }
          {if (true) return dependencies;}
    throw new Error("Missing return statement in function");
  }

  final public ComponentNode ComponentNode() throws ParseException {
        List<ClassNode> impls = null;
        ClassNode _impl;

        List<TypedefNode> typedefs = null;
        TypedefNode _typedef;

        String name;
        Set<String> dependencies;

        String principalClassName = null;
        ComponentNode.UnitType unitType = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMPONENT:
    case MODULE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MODULE:
        jj_consume_token(MODULE);
                     unitType = ComponentNode.UnitType.Module;
        break;
      case COMPONENT:
        jj_consume_token(COMPONENT);
                        unitType = ComponentNode.UnitType.Component;
        break;
      default:
        jj_la1[3] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    name = FQN();
    jj_consume_token(SEMICOLON);
    dependencies = Dependencies();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYPEDEF:
      case TYPE:
      case CLASS:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYPEDEF:
        _typedef = TypedefNode();
                                   typedefs = add(typedefs, _typedef);
        break;
      case TYPE:
        _typedef = TypedefSugar();
                                    typedefs = add(typedefs, _typedef);
        break;
      case CLASS:
        _impl = ClassNode();
                              impls = add(impls, _impl);
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          {if (true) return new ComponentNode(name, impls, typedefs, dependencies, unitType);}
    throw new Error("Missing return statement in function");
  }

  final public ClassNode ClassNode() throws ParseException {
    String ident;
    List<MethodNode> methods = null;
    MethodNode _meth;
    List<AttributeNode> attributes = null;
    List<String> inherits_from = null;
    String _super;
    AttributeNode _attr;
    DebugInfo dbg;
    jj_consume_token(CLASS);
                  dbg = makeDbgInfo(token);
    ident = Identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      _super = Identifier();
                                    inherits_from = add(inherits_from, _super);
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[7] = jj_gen;
          break label_3;
        }
        jj_consume_token(COMMA);
        _super = Identifier();
                                     inherits_from = add(inherits_from, _super);
      }
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUN:
      case MTH:
      case VAR:
      case PUBLIC:
      case PROTECTED:
      case PRIVATE:
      case STATIC:
      case OPTIONAL:
        ;
        break;
      default:
        jj_la1[9] = jj_gen;
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUN:
      case MTH:
      case PUBLIC:
      case PROTECTED:
      case PRIVATE:
      case STATIC:
      case OPTIONAL:
        _meth = MethodNode(false);
                                    methods = add(methods, _meth);
        break;
      case VAR:
        _attr = AttributeNode();
                                  attributes = add(attributes, _attr);
        break;
      default:
        jj_la1[10] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(RBRACE);
                ClassNode res = new ClassNode(ident, methods, attributes, inherits_from);
                res.debugInfo = dbg;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public List<IdentifierWithType> IdentifierWithTypeList(boolean allowUnsafe) throws ParseException {
    List<IdentifierWithType> idents = null;
    IdentifierWithType cur;
    cur = IdentifierWithType(allowUnsafe);
                                            idents = add(idents, cur);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_5;
      }
      jj_consume_token(COMMA);
      cur = IdentifierWithType(allowUnsafe);
                                                  idents = add(idents, cur);
    }
          {if (true) return idents;}
    throw new Error("Missing return statement in function");
  }

  final public IdentifierWithType IdentifierWithType(boolean allowUnsafe) throws ParseException {
    String ident;
    AbstractType type;
    boolean safe = true;
    DebugInfo dbg;
    ident = Identifier();
                           dbg = makeDbgInfo(token);
    jj_consume_token(COLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case UNSAFE:
      jj_consume_token(UNSAFE);
                 safe = false;
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
    type = AbstractType();
        IdentifierWithType res = new IdentifierWithType(ident, type, safe);
        res.debugInfo = dbg;
        {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public TypedefNode TypedefNode() throws ParseException {
    String ident;
    AbstractType type = null;
    DebugInfo dbg;
    jj_consume_token(TYPEDEF);
                dbg = makeDbgInfo(token);
    ident = Identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
      type = AbstractType();
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
            TypedefNode res = new TypedefNode(ident, type);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public TypedefNode TypedefSugar() throws ParseException {
    String ident;
    AbstractType type = null;
    DebugInfo dbg;
    jj_consume_token(TYPE);
             dbg = makeDbgInfo(token);
    ident = Identifier();
    type = AbstractType();
            TypedefNode res = new TypedefNode(ident, type);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public MethodNode MethodNode(boolean forceAbstract) throws ParseException {
    String ident;
    List<IdentifierWithType> params = null;
    List<AbstractType> results = null;
    AbstractType result = null;
    boolean statik = false;
    boolean optional = false;
    BlockStm body = null;
    ModifierNode mod;
    DebugInfo dbg;
    mod = AccessModifierNode();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STATIC:
      jj_consume_token(STATIC);
                     statik = true;
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPTIONAL:
      jj_consume_token(OPTIONAL);
                       optional = true;
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
      jj_consume_token(FUN);
      break;
    case MTH:
      jj_consume_token(MTH);
      break;
    default:
      jj_la1[16] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                          dbg = makeDbgInfo(token);
    ident = Identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        params = IdentifierWithTypeList(forceAbstract);
        break;
      default:
        jj_la1[17] = jj_gen;
        ;
      }
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      if (jj_2_1(3)) {
        results = ResultTypeList(forceAbstract);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LOCAL:
        case EXTERN:
        case TRANSIENT:
        case INTIMATE:
        case BYTE:
        case INT:
        case INT8:
        case INT16:
        case INT32:
        case INT64:
        case FLOAT:
        case DOUBLE:
        case BOOL:
        case REF:
        case LPAREN:
        case LBRACE:
        case IDENTIFIER:
          result = AbstractType();
                                                                                                results = add(results,result);
          break;
        default:
          jj_la1[19] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACE:
      body = BlockStm();
      break;
    default:
      jj_la1[21] = jj_gen;
      ;
    }
                MethodNode res = new MethodNode(ident, params, results, mod, statik, optional, body);
                res.debugInfo = dbg;
                if (forceAbstract) {
                    if (body != null)
                        {if (true) throw new ParseException("Method body found where abstract methods expected. " + res.toString());}
                    if (statik)
                        {if (true) throw new ParseException("Abstract methods cannot be static. " + res.toString());}
                    if (mod != ModifierNode.PUBLIC)
                        {if (true) throw new ParseException("Only public methods allowed in structural types. " + res.toString());}
                } else if (optional) {
                    {if (true) throw new ParseException("Classes cannot contain optionals. " + res.toString());}
                }
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public BlockStm BlockStm() throws ParseException {
    BlockStm block = new BlockStm();
    List<Stm> stms = block.getStms();
    Stm stm;
    DebugInfo dbg;
    jj_consume_token(LBRACE);
          dbg = makeDbgInfo(token);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUN:
      case MTH:
      case VAR:
      case VAL:
      case IF:
      case RETURN:
      case TRUE:
      case FALSE:
      case WHILE:
      case FOR:
      case BREAK:
      case CONTINUE:
      case THIS:
      case NEW:
      case ASM:
      case NULL:
      case TRY:
      case SWITCH:
      case DATE:
      case TIME:
      case LPAREN:
      case LBRACE:
      case PLUS:
      case MINUS:
      case NOT:
      case IDENTIFIER:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
        ;
        break;
      default:
        jj_la1[22] = jj_gen;
        break label_6;
      }
      stm = Stm();
                    stms = add(stms, stm);
    }
    jj_consume_token(RBRACE);
                block.debugInfo = dbg;
                {if (true) return block;}
    throw new Error("Missing return statement in function");
  }

  final public Stm SwitchStm() throws ParseException {
    DebugInfo dbg;
    Exp switchExp;
    Exp condition;
    Map<Exp, Stm> cases = new LinkedHashMap<Exp, Stm>();
    Stm stm, defaultCase = null;
    jj_consume_token(SWITCH);
               dbg = makeDbgInfo(token);
    jj_consume_token(LPAREN);
    switchExp = IdExp();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_7:
    while (true) {
      jj_consume_token(CASE);
      condition = Exp();
      jj_consume_token(COLON);
      stm = Stm();
                                                     cases.put(condition, stm);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CASE:
        ;
        break;
      default:
        jj_la1[23] = jj_gen;
        break label_7;
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEFLT:
      jj_consume_token(DEFLT);
      jj_consume_token(COLON);
      defaultCase = Stm();
      break;
    default:
      jj_la1[24] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
        SwitchStm result = new SwitchStm(switchExp, defaultCase);
        result.getCases().putAll(cases);
        result.debugInfo = dbg;
        {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Stm TryCatchStm() throws ParseException {
    DebugInfo dbg;
    Stm tryStm;
    Stm catchStm;
    jj_consume_token(TRY);
            dbg = makeDbgInfo(token);
    tryStm = Stm();
    jj_consume_token(CATCH);
    catchStm = Stm();
            Stm res = new TryCatchStm(tryStm, catchStm);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm AssignStm() throws ParseException {
    Exp lhs;
    Exp rhs;
    DebugInfo dbg;
    lhs = Exp();
                  dbg = makeDbgInfo(token);
    jj_consume_token(ASSIGN);
    rhs = Exp();
            AssignStm res = new AssignStm(lhs, rhs);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm VarStm() throws ParseException {
    Exp init = null;
    String name;
    AbstractType type = null;
    boolean isConst = false;
    DebugInfo dbg;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      jj_consume_token(VAR);
      break;
    case VAL:
      jj_consume_token(VAL);
      break;
    default:
      jj_la1[25] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        dbg = makeDbgInfo(token); isConst = token.image.equals("val");
    name = Identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      type = AbstractType();
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGN:
      jj_consume_token(ASSIGN);
      init = Exp();
      break;
    default:
      jj_la1[27] = jj_gen;
      ;
    }
                VarStm res = new VarStm(name, type, init, isConst);
                res.debugInfo = dbg;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm IfStm() throws ParseException {
    Exp condition;
    Stm doThen;
    Stm doElse = null;
    DebugInfo dbg;
    jj_consume_token(IF);
           dbg = makeDbgInfo(token);
    jj_consume_token(LPAREN);
    condition = Exp();
    jj_consume_token(RPAREN);
    doThen = Stm();
    if (jj_2_2(2)) {
      jj_consume_token(ELSE);
      doElse = Stm();
    } else {
      ;
    }
                IfStm res = new IfStm(condition, doThen, doElse);
                res.debugInfo = dbg;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm ForStm() throws ParseException {
    Stm init = null;
    Exp testExp = null;
    Stm advance = null;
    Stm body;
    DebugInfo dbg;
    jj_consume_token(FOR);
            dbg = makeDbgInfo(token);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case VAR:
    case VAL:
    case RETURN:
    case TRUE:
    case FALSE:
    case BREAK:
    case CONTINUE:
    case THIS:
    case NEW:
    case ASM:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      init = StmWithoutSemicolon();
      break;
    default:
      jj_la1[28] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case TRUE:
    case FALSE:
    case THIS:
    case NEW:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      testExp = Exp();
      break;
    default:
      jj_la1[29] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case VAR:
    case VAL:
    case RETURN:
    case TRUE:
    case FALSE:
    case BREAK:
    case CONTINUE:
    case THIS:
    case NEW:
    case ASM:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      advance = StmWithoutSemicolon();
      break;
    default:
      jj_la1[30] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    body = Stm();
            ForStm res = new ForStm(init, testExp, advance, body);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm WhileStm() throws ParseException {
    Exp condition;
    Stm doStm;
    DebugInfo dbg;
    jj_consume_token(WHILE);
              dbg = makeDbgInfo(token);
    jj_consume_token(LPAREN);
    condition = Exp();
    jj_consume_token(RPAREN);
    doStm = Stm();
            WhileStm res = new WhileStm(condition, doStm);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm BreakOrContinue() throws ParseException {
    Stm res;
    DebugInfo dbg;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONTINUE:
      jj_consume_token(CONTINUE);
                  res = new ContinueStm();
      break;
    case BREAK:
      jj_consume_token(BREAK);
               res = new BreakStm();
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
         dbg = makeDbgInfo(token);
        res.debugInfo = dbg;
        {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm ExpStm() throws ParseException {
    Exp exp;
    exp = SingleExp(null);
            ExpStm res = new ExpStm(exp);
            res.debugInfo = exp.debugInfo;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm AsmStm() throws ParseException {
    String code;
    List<Exp> args = null;
    Exp e;
    DebugInfo dbg;
    jj_consume_token(ASM);
                dbg = makeDbgInfo(token);
    jj_consume_token(LPAREN);
    jj_consume_token(STRING_LITERAL);
                           code = token.image.replaceAll("^.|.$", "");
    label_8:
    while (true) {
      jj_consume_token(COMMA);
      e = Exp();
                      args = add(args, e);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[32] = jj_gen;
        break label_8;
      }
    }
    jj_consume_token(RPAREN);
                Stm res = new AsmStm(code, args);
                res.debugInfo = dbg;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Stm StmWithoutSemicolon() throws ParseException {
    Stm stm = null;
    if (jj_2_3(2147483647)) {
      stm = AssignStm();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUN:
      case MTH:
      case TRUE:
      case FALSE:
      case THIS:
      case NEW:
      case NULL:
      case DATE:
      case TIME:
      case LPAREN:
      case PLUS:
      case MINUS:
      case NOT:
      case IDENTIFIER:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
        stm = ExpStm();
        break;
      case VAR:
      case VAL:
        stm = VarStm();
        break;
      case BREAK:
      case CONTINUE:
        stm = BreakOrContinue();
        break;
      case RETURN:
        stm = ReturnStm();
        break;
      case ASM:
        stm = AsmStm();
        break;
      default:
        jj_la1[33] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          {if (true) return stm;}
    throw new Error("Missing return statement in function");
  }

  final public Stm Stm() throws ParseException {
    Stm stm = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case VAR:
    case VAL:
    case RETURN:
    case TRUE:
    case FALSE:
    case BREAK:
    case CONTINUE:
    case THIS:
    case NEW:
    case ASM:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      stm = StmWithoutSemicolon();
      jj_consume_token(SEMICOLON);
      break;
    case IF:
    case WHILE:
    case FOR:
    case TRY:
    case SWITCH:
    case LBRACE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRY:
        stm = TryCatchStm();
        break;
      case SWITCH:
        stm = SwitchStm();
        break;
      case IF:
        stm = IfStm();
        break;
      case FOR:
        stm = ForStm();
        break;
      case WHILE:
        stm = WhileStm();
        break;
      case LBRACE:
        stm = BlockStm();
        break;
      default:
        jj_la1[34] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[35] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
          {if (true) return stm;}
    throw new Error("Missing return statement in function");
  }

  final public Exp AnonFunctionExp() throws ParseException {
    List<IdentifierWithType> params = null;
    List<AbstractType> results = null;
    AbstractType result = null;
    BlockStm body = null;
    DebugInfo dbg;
    List<Exp> captures = null;
    Exp cap = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
      jj_consume_token(FUN);
      break;
    case MTH:
      jj_consume_token(MTH);
      break;
    default:
      jj_la1[36] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
                        dbg = makeDbgInfo(token);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACKET:
      jj_consume_token(LBRACKET);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUN:
      case MTH:
      case TRUE:
      case FALSE:
      case THIS:
      case NEW:
      case NULL:
      case DATE:
      case TIME:
      case LPAREN:
      case PLUS:
      case MINUS:
      case NOT:
      case IDENTIFIER:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
        cap = Exp();
                         captures = add(captures, cap);
        label_9:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[37] = jj_gen;
            break label_9;
          }
          jj_consume_token(COMMA);
          cap = Exp();
                               captures = add(captures, cap);
        }
        break;
      default:
        jj_la1[38] = jj_gen;
        ;
      }
      jj_consume_token(RBRACKET);
      break;
    default:
      jj_la1[39] = jj_gen;
      ;
    }
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      params = IdentifierWithTypeList(false);
      break;
    default:
      jj_la1[40] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      if (jj_2_4(3)) {
        results = ResultTypeList(false);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LOCAL:
        case EXTERN:
        case TRANSIENT:
        case INTIMATE:
        case BYTE:
        case INT:
        case INT8:
        case INT16:
        case INT32:
        case INT64:
        case FLOAT:
        case DOUBLE:
        case BOOL:
        case REF:
        case LPAREN:
        case LBRACE:
        case IDENTIFIER:
          result = AbstractType();
                                                                                        results = add(results,result);
          break;
        default:
          jj_la1[41] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      break;
    default:
      jj_la1[42] = jj_gen;
      ;
    }
    body = BlockStm();
            Exp exp = new AnonFunctionExp(params, results, body, captures);
            exp.debugInfo = dbg;
            {if (true) return exp;}
    throw new Error("Missing return statement in function");
  }

  final public Exp LiteralExp() throws ParseException {
    Exp exp;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      jj_consume_token(INTEGER_LITERAL);
                         exp = new LiteralExp(Integer.valueOf(token.image));
      break;
    case FLOATING_POINT_LITERAL:
      jj_consume_token(FLOATING_POINT_LITERAL);
         if (token.image.endsWith("d"))
             exp = new LiteralExp(Double.valueOf(token.image));
         else
             exp = new LiteralExp(Float.valueOf(token.image).floatValue());
      break;
    case STRING_LITERAL:
      jj_consume_token(STRING_LITERAL);
                        exp = new LiteralExp(token.image.replaceAll("^.|.$", ""), false);
      break;
    case DATE:
      jj_consume_token(DATE);
                  exp = new LiteralExp(java.time.LocalDate.now().toString(), false);
      break;
    case TIME:
      jj_consume_token(TIME);
                  exp = new LiteralExp(java.time.LocalTime.now().toString(), false);
      break;
    case CHARACTER_LITERAL:
      jj_consume_token(CHARACTER_LITERAL);
                           exp = new LiteralExp(token.image.replaceAll("^.|.$", ""), true);
      break;
    case TRUE:
    case FALSE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRUE:
        jj_consume_token(TRUE);
        break;
      case FALSE:
        jj_consume_token(FALSE);
        break;
      default:
        jj_la1[43] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                            exp = new LiteralExp(Boolean.valueOf(token.image));
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
            exp.debugInfo = makeDbgInfo(token);
            {if (true) return exp;}
    throw new Error("Missing return statement in function");
  }

  final public Exp NullExp() throws ParseException {
    Exp exp;
    jj_consume_token(NULL);
             exp = new LiteralExp();
        exp.debugInfo = makeDbgInfo(token);
        {if (true) return exp;}
    throw new Error("Missing return statement in function");
  }

  final public Exp IncreaseOrDecreaseExp() throws ParseException {
    String identifier;
    DebugInfo dbg;
    boolean decrease = false;
    identifier = Identifier();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 105:
      jj_consume_token(105);
      break;
    case 106:
      jj_consume_token(106);
                       decrease = true;
      break;
    default:
      jj_la1[45] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
            {if (true) return new IncreaseOrDecreaseExp(identifier, decrease, true);}
    throw new Error("Missing return statement in function");
  }

  final public Exp UnaryExp() throws ParseException {
    Exp exp;
    UnaryExp.Operator op;
    DebugInfo dbg;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PLUS:
      jj_consume_token(PLUS);
           op = UnaryExp.Operator.PLUS;
      break;
    case MINUS:
      jj_consume_token(MINUS);
           op = UnaryExp.Operator.MINUS;
      break;
    case NOT:
      jj_consume_token(NOT);
           op = UnaryExp.Operator.NOT;
      break;
    default:
      jj_la1[46] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
         dbg = makeDbgInfo(token);
    exp = Exp();
            UnaryExp res =  new UnaryExp(op, exp);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp EnclosedExp() throws ParseException {
    Exp exp;
    DebugInfo dbg;
    jj_consume_token(LPAREN);
          dbg = makeDbgInfo(token);
    exp = Exp();
    jj_consume_token(RPAREN);
            Exp res =  new EnclosedExp(exp);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp MultiplicativeExp() throws ParseException {
    Exp lhs;
    Exp rhs = null;
    BinaryExp.Operator op = null;
    lhs = SingleExp(null);
    if (jj_2_5(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case MULT:
        jj_consume_token(MULT);
                              op = BinaryExp.Operator.MULT;
        break;
      case DIV:
        jj_consume_token(DIV);
                              op = BinaryExp.Operator.DIV;
        break;
      case MOD:
        jj_consume_token(MOD);
                              op = BinaryExp.Operator.MOD;
        break;
      case AND:
        jj_consume_token(AND);
                               op = BinaryExp.Operator.MULT;
        break;
      default:
        jj_la1[47] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      rhs = MultiplicativeExp();
    } else {
      ;
    }
                if (rhs == null)
                    {if (true) return lhs;}
                BinaryExp res = new BinaryExp(op, lhs, rhs);
                res.debugInfo = lhs.debugInfo;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp AdditiveExp() throws ParseException {
    Exp lhs;
    Exp rhs = null;
    BinaryExp.Operator op = null;
    lhs = MultiplicativeExp();
    if (jj_2_6(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
                              op = BinaryExp.Operator.PLUS;
        break;
      case MINUS:
        jj_consume_token(MINUS);
                              op = BinaryExp.Operator.MINUS;
        break;
      case 107:
        jj_consume_token(107);
                               op = BinaryExp.Operator.CONS;
        break;
      case OR:
        jj_consume_token(OR);
                               op = BinaryExp.Operator.PLUS;
        break;
      default:
        jj_la1[48] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      rhs = Exp();
    } else {
      ;
    }
                if (rhs == null)
                    {if (true) return lhs;}
                BinaryExp res = new BinaryExp(op, lhs, rhs);
                res.debugInfo = lhs.debugInfo;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp ConditionalExp() throws ParseException {
    Exp lhs;
    //AbstractType type = null;
    Exp rhs = null;
    ConditionalExp.Operator op = null;
    lhs = AdditiveExp();
    if (jj_2_7(2)) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
        jj_consume_token(EQ);
                               op = ConditionalExp.Operator.EQ;
        break;
      case NEQ:
        jj_consume_token(NEQ);
                               op = ConditionalExp.Operator.NEQ;
        break;
      case LT:
        jj_consume_token(LT);
                              op = ConditionalExp.Operator.LT;
        break;
      case LEQ:
        jj_consume_token(LEQ);
                               op = ConditionalExp.Operator.LEQ;
        break;
      case GT:
        jj_consume_token(GT);
                              op = ConditionalExp.Operator.GT;
        break;
      case GEQ:
        jj_consume_token(GEQ);
                               op = ConditionalExp.Operator.GEQ;
        break;
      default:
        jj_la1[49] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      rhs = AdditiveExp();
    } else {
      ;
    }
                if (rhs == null)
                    {if (true) return lhs;}
                ConditionalExp res = new ConditionalExp(op, lhs, rhs);
                res.debugInfo = lhs.debugInfo;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp CallExp(Exp scope) throws ParseException {
    String methodName;
    List<Exp> args = null;
    Exp arg = null;
    DebugInfo dbg;
    methodName = Identifier();
                                dbg = makeDbgInfo(token);
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case TRUE:
    case FALSE:
    case THIS:
    case NEW:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      arg = Exp();
                       args = add(args, arg);
      label_10:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[50] = jj_gen;
          break label_10;
        }
        jj_consume_token(COMMA);
        arg = Exp();
                            args = add(args, arg);
      }
      break;
    default:
      jj_la1[51] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
                CallExp res = new CallExp(scope, methodName, args);
                res.debugInfo = dbg;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp FieldAccessExp(Exp scope) throws ParseException {
    Exp field;
    field = IdExp();
            if (scope == null)
                {if (true) return field;}

            FieldAccessExp res = new FieldAccessExp(scope, (IdExp)field);
            res.debugInfo = scope.debugInfo;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public List<Exp> ExpList() throws ParseException {
    List<Exp> expressions = null;
    Exp current;
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case TRUE:
    case FALSE:
    case THIS:
    case NEW:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      current = Exp();
                           expressions = add(expressions, current);
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[52] = jj_gen;
          break label_11;
        }
        jj_consume_token(COMMA);
        current = Exp();
                                expressions = add(expressions, current);
      }
      break;
    default:
      jj_la1[53] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
              {if (true) return expressions;}
    throw new Error("Missing return statement in function");
  }

  final public List<Exp> Indices() throws ParseException {
    List<Exp> indices = null;
    Exp current;
    jj_consume_token(LBRACKET);
    current = Exp();
                          indices = add(indices, current);
    jj_consume_token(RBRACKET);
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        ;
        break;
      default:
        jj_la1[54] = jj_gen;
        break label_12;
      }
      jj_consume_token(LBRACKET);
      current = Exp();
                                                                                         indices = add(indices, current);
      jj_consume_token(RBRACKET);
    }
                                                                       {if (true) return indices;}
    throw new Error("Missing return statement in function");
  }

  final public Exp NewExp() throws ParseException {
    AbstractType type;
    List<Exp> args = null;
    List<Exp> sizes = null;
    DebugInfo dbg;
    jj_consume_token(NEW);
            dbg = makeDbgInfo(token);
    type = AbstractType();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
    case LBRACKET:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        args = ExpList();
        break;
      case LBRACKET:
        sizes = Indices();
        break;
      default:
        jj_la1[55] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[56] = jj_gen;
      ;
    }
                Exp res;
                if (sizes == null && type instanceof TypeIdentifier) {
                    TypeIdentifier named = (TypeIdentifier) type;
                    res = new NewExp(named.getName(), args);
                } else if (sizes == null) {
                    {if (true) throw new ParseException("Cannot instantiate primitive type.");}
                } else {
                    ArrayType array_t = new ArrayType(type, sizes.size());
                    res = new NewArrayExp(array_t, sizes);
                }
                res.debugInfo = dbg;
                {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp TypeVerdictExp() throws ParseException {
    Exp exp;
    AbstractType t;
    exp = IdExp();
    jj_consume_token(COLON);
    t = AbstractType();
            Exp res = new TypeVerdictExp(exp, t);
            res.debugInfo = exp.debugInfo;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp SingleExp(Exp scope) throws ParseException {
    Exp exp;
    if (jj_2_8(2147483647)) {
      exp = CallExp(scope);
    } else if (jj_2_9(2147483647)) {
      exp = TypeVerdictExp();
    } else if (jj_2_10(2147483647)) {
      exp = IncreaseOrDecreaseExp();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        exp = FieldAccessExp(scope);
        break;
      case LPAREN:
        exp = EnclosedExp();
        break;
      case PLUS:
      case MINUS:
      case NOT:
        exp = UnaryExp();
        break;
      case NULL:
        exp = NullExp();
        break;
      case TRUE:
      case FALSE:
      case DATE:
      case TIME:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
        exp = LiteralExp();
        break;
      case THIS:
        exp = ThisExp();
        break;
      case NEW:
        exp = NewExp();
        break;
      case FUN:
      case MTH:
        exp = AnonFunctionExp();
        break;
      default:
        jj_la1[57] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    if (jj_2_11(2)) {
      jj_consume_token(DOT);
      exp = SingleExp(exp);
    } else {
      ;
    }
              {if (true) return exp;}
    throw new Error("Missing return statement in function");
  }

  final public Exp Exp() throws ParseException {
    Exp exp;
    if (jj_2_12(2147483647)) {
      exp = ConditionalExp();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUN:
      case MTH:
      case TRUE:
      case FALSE:
      case THIS:
      case NEW:
      case NULL:
      case DATE:
      case TIME:
      case LPAREN:
      case PLUS:
      case MINUS:
      case NOT:
      case IDENTIFIER:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
        exp = SingleExp(null);
        break;
      default:
        jj_la1[58] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          {if (true) return exp;}
    throw new Error("Missing return statement in function");
  }

  final public Exp IdExp() throws ParseException {
    String ident;
    List<Exp> indices = null;
    Exp index;
    DebugInfo dbg;
    ident = Identifier();
                           dbg = makeDbgInfo(token);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LBRACKET:
      indices = Indices();
      break;
    default:
      jj_la1[59] = jj_gen;
      ;
    }
            IdExp res = new IdExp(ident, indices);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public Exp ThisExp() throws ParseException {
    jj_consume_token(THIS);
            ThisExp res = new ThisExp();
            res.debugInfo = makeDbgInfo(token);
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public ReturnStm ReturnStm() throws ParseException {
    ReturnStm stm;
    List<Exp> expr = null;
    Exp cur = null;
    DebugInfo dbg;
    jj_consume_token(RETURN);
               dbg = makeDbgInfo(token);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUN:
    case MTH:
    case TRUE:
    case FALSE:
    case THIS:
    case NEW:
    case NULL:
    case DATE:
    case TIME:
    case LPAREN:
    case PLUS:
    case MINUS:
    case NOT:
    case IDENTIFIER:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      cur = Exp();
                   expr = add(expr, cur);
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[60] = jj_gen;
          break label_13;
        }
        jj_consume_token(COMMA);
        cur = Exp();
                        expr = add(expr, cur);
      }
      break;
    default:
      jj_la1[61] = jj_gen;
      ;
    }
            ReturnStm res = new ReturnStm(expr);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public List<AbstractType> ResultTypeList(boolean allowUnsafe) throws ParseException {
    List<AbstractType> types = null;
    AbstractType cur;
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LOCAL:
    case EXTERN:
    case TRANSIENT:
    case INTIMATE:
    case BYTE:
    case INT:
    case INT8:
    case INT16:
    case INT32:
    case INT64:
    case FLOAT:
    case DOUBLE:
    case BOOL:
    case REF:
    case LPAREN:
    case LBRACE:
    case IDENTIFIER:
      cur = AbstractType();
                                types = add(types, cur);
      label_14:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[62] = jj_gen;
          break label_14;
        }
        jj_consume_token(COMMA);
        cur = AbstractType();
                                      types = add(types, cur);
      }
      break;
    default:
      jj_la1[63] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
              {if (true) return types;}
    throw new Error("Missing return statement in function");
  }

  final public AbstractType StructuralType() throws ParseException {
    List<MethodNode> methods = null;
    MethodNode _meth;
    AbstractType type = null;
    String externName = null;
    DebugInfo dbg;
    boolean isExtern = false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EXTERN:
      jj_consume_token(EXTERN);
                   isExtern = true;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        externName = Identifier();
        break;
      default:
        jj_la1[64] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[65] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
              dbg = makeDbgInfo(token);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LOCAL:
    case EXTERN:
    case TRANSIENT:
    case INTIMATE:
    case BYTE:
    case INT:
    case INT8:
    case INT16:
    case INT32:
    case INT64:
    case FLOAT:
    case DOUBLE:
    case BOOL:
    case REF:
    case LPAREN:
    case LBRACE:
    case IDENTIFIER:
      type = AbstractType();
      break;
    default:
      jj_la1[67] = jj_gen;
      label_15:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FUN:
        case MTH:
        case PUBLIC:
        case PROTECTED:
        case PRIVATE:
        case STATIC:
        case OPTIONAL:
          ;
          break;
        default:
          jj_la1[66] = jj_gen;
          break label_15;
        }
        _meth = MethodNode(true);
                                     methods = add(methods, _meth);
        jj_consume_token(SEMICOLON);
      }
    }
    jj_consume_token(RBRACE);
        StructuralType res = new StructuralType(methods, type, externName, isExtern);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public int TypeAssertionsNode() throws ParseException {
    int is_local = 0;
    int is_final = 0;
    int is_intimate = 0;
    int is_transient = 0;
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LOCAL:
      case TRANSIENT:
      case INTIMATE:
        ;
        break;
      default:
        jj_la1[68] = jj_gen;
        break label_16;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LOCAL:
        jj_consume_token(LOCAL);
              is_local = 1;
        break;
      case INTIMATE:
        jj_consume_token(INTIMATE);
                 is_intimate = 2;
        jj_consume_token(FINAL);
              is_final = 4;
        break;
      case TRANSIENT:
        jj_consume_token(TRANSIENT);
                  is_transient = 8;
        break;
      default:
        jj_la1[69] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return is_local | is_final | is_transient | is_intimate;}
    throw new Error("Missing return statement in function");
  }

  final public AbstractType AbstractType() throws ParseException {
    AbstractType type;
    int assertions;
    int dims = 0;
    assertions = TypeAssertionsNode();
    if (jj_2_13(2147483647)) {
      type = FunctionalType();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BYTE:
      case INT:
      case INT8:
      case INT16:
      case INT32:
      case INT64:
      case FLOAT:
      case DOUBLE:
      case BOOL:
      case REF:
        type = SimpleType();
        break;
      case IDENTIFIER:
        type = TypeIdentifier();
        break;
      case EXTERN:
      case LBRACE:
        type = StructuralType();
        break;
      case LPAREN:
        type = EnclosedType();
        break;
      default:
        jj_la1[70] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    label_17:
    while (true) {
      if (jj_2_14(2)) {
        ;
      } else {
        break label_17;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
                                 dims++;
    }
        if (dims == 0) {
            type.setAssertions(assertions);
            {if (true) return type;}
        }
        AbstractType type_array = new ArrayType(type, dims);
        type_array.debugInfo = type.debugInfo;
        {if (true) return type_array;}
    throw new Error("Missing return statement in function");
  }

  final public AbstractType EnclosedType() throws ParseException {
    AbstractType type;
    DebugInfo dbg;
    jj_consume_token(LPAREN);
    type = AbstractType();
    jj_consume_token(RPAREN);
        {if (true) return type;}
    throw new Error("Missing return statement in function");
  }

  final public AbstractType SimpleType() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BYTE:
      jj_consume_token(BYTE);
      break;
    case BOOL:
      jj_consume_token(BOOL);
      break;
    case INT:
      jj_consume_token(INT);
      break;
    case INT8:
      jj_consume_token(INT8);
      break;
    case INT16:
      jj_consume_token(INT16);
      break;
    case INT32:
      jj_consume_token(INT32);
      break;
    case INT64:
      jj_consume_token(INT64);
      break;
    case FLOAT:
      jj_consume_token(FLOAT);
      break;
    case DOUBLE:
      jj_consume_token(DOUBLE);
      break;
    case REF:
      jj_consume_token(REF);
      break;
    default:
      jj_la1[71] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        SimpleType res = new SimpleType(token.image);
        res.debugInfo = makeDbgInfo(token);
        {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public AbstractType TypeIdentifier() throws ParseException {
    String ident;
    ident = Identifier();
            TypeIdentifier res = new TypeIdentifier(ident);
            res.debugInfo = makeDbgInfo(token);
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public AbstractType FunctionalType() throws ParseException {
    List<AbstractType> from = null;
    List<AbstractType> to = null;
    AbstractType cur = null;
    from = ResultTypeList(false);
    jj_consume_token(ARROW);
    to = ResultTypeList(false);
          {if (true) return new FunctionalType(from, to);}
    throw new Error("Missing return statement in function");
  }

  final public AttributeNode AttributeNode() throws ParseException {
    boolean is_const = false;
    IdentifierWithType ident;
    boolean statik = false;
    DebugInfo dbg;
    jj_consume_token(VAR);
            dbg = makeDbgInfo(token);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STATIC:
      jj_consume_token(STATIC);
                 statik = true;
      break;
    default:
      jj_la1[72] = jj_gen;
      ;
    }
    ident = IdentifierWithType(false);
    jj_consume_token(SEMICOLON);
            AttributeNode res = new AttributeNode(ident, is_const, statik);
            res.debugInfo = dbg;
            {if (true) return res;}
    throw new Error("Missing return statement in function");
  }

  final public String Identifier() throws ParseException {
    jj_consume_token(IDENTIFIER);
                   {if (true) return token.image;}
    throw new Error("Missing return statement in function");
  }

  final public String FQN() throws ParseException {
        String name;
        String tmp;
    name = Identifier();
    label_18:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        ;
        break;
      default:
        jj_la1[73] = jj_gen;
        break label_18;
      }
      jj_consume_token(DOT);
      tmp = Identifier();
                                   name += "." + tmp;
    }
          {if (true) return name;}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  private boolean jj_3R_140() {
    if (jj_3R_102()) return true;
    return false;
  }

  private boolean jj_3R_40() {
    if (jj_3R_52()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_118() {
    if (jj_3R_42()) return true;
    return false;
  }

  private boolean jj_3R_162() {
    if (jj_scan_token(PROTECTED)) return true;
    return false;
  }

  private boolean jj_3R_161() {
    if (jj_scan_token(PRIVATE)) return true;
    return false;
  }

  private boolean jj_3R_160() {
    if (jj_scan_token(PUBLIC)) return true;
    return false;
  }

  private boolean jj_3R_155() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_160()) {
    jj_scanpos = xsp;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_145() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_155()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_131() {
    if (jj_scan_token(BREAK)) return true;
    return false;
  }

  private boolean jj_3R_130() {
    if (jj_scan_token(CONTINUE)) return true;
    return false;
  }

  private boolean jj_3R_139() {
    if (jj_3R_151()) return true;
    return false;
  }

  private boolean jj_3R_134() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_139()) {
    jj_scanpos = xsp;
    if (jj_3R_140()) return true;
    }
    return false;
  }

  private boolean jj_3R_120() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_130()) {
    jj_scanpos = xsp;
    if (jj_3R_131()) return true;
    }
    return false;
  }

  private boolean jj_3R_88() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_53()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_134()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_100() {
    if (jj_scan_token(WHILE)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_31()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3R_102() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_31()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_123()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_168() {
    if (jj_3R_67()) return true;
    return false;
  }

  private boolean jj_3R_163() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_167() {
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_158() {
    if (jj_3R_31()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_163()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_166() {
    if (jj_3R_67()) return true;
    return false;
  }

  private boolean jj_3R_151() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_158()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_99() {
    if (jj_scan_token(FOR)) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_166()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_167()) jj_scanpos = xsp;
    if (jj_scan_token(SEMICOLON)) return true;
    xsp = jj_scanpos;
    if (jj_3R_168()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3R_82() {
    if (jj_3R_52()) return true;
    return false;
  }

  private boolean jj_3R_98() {
    if (jj_scan_token(IF)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_31()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_3R_20()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_74() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_50() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_51() {
    if (jj_3R_31()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_74()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_170() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_169() {
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_39() {
    if (jj_3R_50()) return true;
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_51()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_37() {
    if (jj_scan_token(GEQ)) return true;
    return false;
  }

  private boolean jj_3R_36() {
    if (jj_scan_token(GT)) return true;
    return false;
  }

  private boolean jj_3R_119() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(19)) {
    jj_scanpos = xsp;
    if (jj_scan_token(20)) return true;
    }
    if (jj_3R_50()) return true;
    xsp = jj_scanpos;
    if (jj_3R_169()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_170()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_35() {
    if (jj_scan_token(LEQ)) return true;
    return false;
  }

  private boolean jj_3R_34() {
    if (jj_scan_token(LT)) return true;
    return false;
  }

  private boolean jj_3R_33() {
    if (jj_scan_token(NEQ)) return true;
    return false;
  }

  private boolean jj_3R_32() {
    if (jj_scan_token(EQ)) return true;
    return false;
  }

  private boolean jj_3_7() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) {
    jj_scanpos = xsp;
    if (jj_3R_35()) {
    jj_scanpos = xsp;
    if (jj_3R_36()) {
    jj_scanpos = xsp;
    if (jj_3R_37()) return true;
    }
    }
    }
    }
    }
    if (jj_3R_38()) return true;
    return false;
  }

  private boolean jj_3R_44() {
    if (jj_3R_19()) return true;
    if (jj_scan_token(ARROW)) return true;
    if (jj_3R_19()) return true;
    return false;
  }

  private boolean jj_3R_21() {
    if (jj_3R_31()) return true;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_43() {
    if (jj_3R_38()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_30() {
    if (jj_scan_token(OR)) return true;
    return false;
  }

  private boolean jj_3R_29() {
    if (jj_scan_token(107)) return true;
    return false;
  }

  private boolean jj_3R_28() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  private boolean jj_3R_27() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  private boolean jj_3R_105() {
    if (jj_3R_50()) return true;
    return false;
  }

  private boolean jj_3R_96() {
    if (jj_scan_token(TRY)) return true;
    if (jj_3R_20()) return true;
    if (jj_scan_token(CATCH)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3_6() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_27()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) {
    jj_scanpos = xsp;
    if (jj_3R_29()) {
    jj_scanpos = xsp;
    if (jj_3R_30()) return true;
    }
    }
    }
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_157() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_38() {
    if (jj_3R_26()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_25() {
    if (jj_scan_token(AND)) return true;
    return false;
  }

  private boolean jj_3R_24() {
    if (jj_scan_token(MOD)) return true;
    return false;
  }

  private boolean jj_3R_165() {
    if (jj_scan_token(DEFLT)) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3R_23() {
    if (jj_scan_token(DIV)) return true;
    return false;
  }

  private boolean jj_3R_164() {
    if (jj_scan_token(CASE)) return true;
    if (jj_3R_31()) return true;
    if (jj_scan_token(COLON)) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3R_22() {
    if (jj_scan_token(MULT)) return true;
    return false;
  }

  private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(53)) {
    jj_scanpos = xsp;
    if (jj_scan_token(61)) {
    jj_scanpos = xsp;
    if (jj_scan_token(54)) {
    jj_scanpos = xsp;
    if (jj_scan_token(55)) {
    jj_scanpos = xsp;
    if (jj_scan_token(56)) {
    jj_scanpos = xsp;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) {
    jj_scanpos = xsp;
    if (jj_scan_token(59)) {
    jj_scanpos = xsp;
    if (jj_scan_token(60)) {
    jj_scanpos = xsp;
    if (jj_scan_token(62)) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_97() {
    if (jj_scan_token(SWITCH)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_52()) return true;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    if (jj_3R_164()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_164()) { jj_scanpos = xsp; break; }
    }
    xsp = jj_scanpos;
    if (jj_3R_165()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3_5() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_22()) {
    jj_scanpos = xsp;
    if (jj_3R_23()) {
    jj_scanpos = xsp;
    if (jj_3R_24()) {
    jj_scanpos = xsp;
    if (jj_3R_25()) return true;
    }
    }
    }
    if (jj_3R_26()) return true;
    return false;
  }

  private boolean jj_3R_107() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_53()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_26() {
    if (jj_3R_42()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_5()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_144() {
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3_13() {
    if (jj_3R_44()) return true;
    return false;
  }

  private boolean jj_3_14() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_101() {
    if (jj_scan_token(LBRACE)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_144()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3R_81() {
    if (jj_3R_107()) return true;
    return false;
  }

  private boolean jj_3R_80() {
    if (jj_3R_106()) return true;
    return false;
  }

  private boolean jj_3R_79() {
    if (jj_3R_105()) return true;
    return false;
  }

  private boolean jj_3R_78() {
    if (jj_3R_104()) return true;
    return false;
  }

  private boolean jj_3R_77() {
    if (jj_3R_44()) return true;
    return false;
  }

  private boolean jj_3R_83() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_31()) return true;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_53() {
    if (jj_3R_76()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_77()) {
    jj_scanpos = xsp;
    if (jj_3R_78()) {
    jj_scanpos = xsp;
    if (jj_3R_79()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) {
    jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    }
    }
    }
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_14()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_1() {
    if (jj_3R_19()) return true;
    return false;
  }

  private boolean jj_3R_156() {
    if (jj_3R_142()) return true;
    return false;
  }

  private boolean jj_3R_150() {
    if (jj_3R_101()) return true;
    return false;
  }

  private boolean jj_3R_149() {
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_1()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) return true;
    }
    return false;
  }

  private boolean jj_3R_148() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_156()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_147() {
    if (jj_scan_token(OPTIONAL)) return true;
    return false;
  }

  private boolean jj_3R_126() {
    if (jj_scan_token(TRANSIENT)) return true;
    return false;
  }

  private boolean jj_3R_146() {
    if (jj_scan_token(STATIC)) return true;
    return false;
  }

  private boolean jj_3R_110() {
    if (jj_scan_token(NOT)) return true;
    return false;
  }

  private boolean jj_3R_125() {
    if (jj_scan_token(INTIMATE)) return true;
    if (jj_scan_token(FINAL)) return true;
    return false;
  }

  private boolean jj_3R_109() {
    if (jj_scan_token(MINUS)) return true;
    return false;
  }

  private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_124()) {
    jj_scanpos = xsp;
    if (jj_3R_125()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_124() {
    if (jj_scan_token(LOCAL)) return true;
    return false;
  }

  private boolean jj_3R_108() {
    if (jj_scan_token(PLUS)) return true;
    return false;
  }

  private boolean jj_3R_76() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_103()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_84() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) return true;
    }
    }
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_138() {
    if (jj_3R_145()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_146()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_147()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) return true;
    }
    if (jj_3R_50()) return true;
    xsp = jj_scanpos;
    if (jj_3R_148()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_149()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3R_150()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_54() {
    if (jj_scan_token(106)) return true;
    return false;
  }

  private boolean jj_3R_133() {
    if (jj_3R_138()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  private boolean jj_3R_129() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_133()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_128() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_41() {
    if (jj_3R_50()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(105)) {
    jj_scanpos = xsp;
    if (jj_3R_54()) return true;
    }
    return false;
  }

  private boolean jj_3R_132() {
    if (jj_3R_50()) return true;
    return false;
  }

  private boolean jj_3R_143() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_127() {
    if (jj_scan_token(EXTERN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_132()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_106() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_127()) jj_scanpos = xsp;
    if (jj_scan_token(LBRACE)) return true;
    xsp = jj_scanpos;
    if (jj_3R_128()) {
    jj_scanpos = xsp;
    if (jj_3R_129()) return true;
    }
    if (jj_scan_token(RBRACE)) return true;
    return false;
  }

  private boolean jj_3R_85() {
    if (jj_scan_token(NULL)) return true;
    return false;
  }

  private boolean jj_3R_66() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_45() {
    if (jj_3R_53()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_66()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_19() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_45()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  private boolean jj_3R_117() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(24)) {
    jj_scanpos = xsp;
    if (jj_scan_token(25)) return true;
    }
    return false;
  }

  private boolean jj_3R_116() {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_115() {
    if (jj_scan_token(TIME)) return true;
    return false;
  }

  private boolean jj_3R_114() {
    if (jj_scan_token(DATE)) return true;
    return false;
  }

  private boolean jj_3R_113() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_112() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_111() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_173() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_86() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_111()) {
    jj_scanpos = xsp;
    if (jj_3R_112()) {
    jj_scanpos = xsp;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) {
    jj_scanpos = xsp;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_159() {
    if (jj_scan_token(UNSAFE)) return true;
    return false;
  }

  private boolean jj_3R_171() {
    if (jj_3R_31()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_173()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_4() {
    if (jj_3R_19()) return true;
    return false;
  }

  private boolean jj_3R_153() {
    if (jj_3R_50()) return true;
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_159()) jj_scanpos = xsp;
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_121() {
    if (jj_scan_token(RETURN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_171()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_136() {
    if (jj_3R_142()) return true;
    return false;
  }

  private boolean jj_3R_152() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_137() {
    if (jj_scan_token(COLON)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3R_143()) return true;
    }
    return false;
  }

  private boolean jj_3R_141() {
    if (jj_3R_31()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_152()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_154() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_153()) return true;
    return false;
  }

  private boolean jj_3R_135() {
    if (jj_scan_token(LBRACKET)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_141()) jj_scanpos = xsp;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_142() {
    if (jj_3R_153()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_154()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_89() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(17)) {
    jj_scanpos = xsp;
    if (jj_scan_token(18)) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_135()) jj_scanpos = xsp;
    if (jj_scan_token(LPAREN)) return true;
    xsp = jj_scanpos;
    if (jj_3R_136()) jj_scanpos = xsp;
    if (jj_scan_token(RPAREN)) return true;
    xsp = jj_scanpos;
    if (jj_3R_137()) jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    return false;
  }

  private boolean jj_3R_87() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  private boolean jj_3R_75() {
    if (jj_3R_102()) return true;
    return false;
  }

  private boolean jj_3R_73() {
    if (jj_3R_101()) return true;
    return false;
  }

  private boolean jj_3R_72() {
    if (jj_3R_100()) return true;
    return false;
  }

  private boolean jj_3R_52() {
    if (jj_3R_50()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_75()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_71() {
    if (jj_3R_99()) return true;
    return false;
  }

  private boolean jj_3R_70() {
    if (jj_3R_98()) return true;
    return false;
  }

  private boolean jj_3R_69() {
    if (jj_3R_97()) return true;
    return false;
  }

  private boolean jj_3R_68() {
    if (jj_3R_96()) return true;
    return false;
  }

  private boolean jj_3R_47() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_3R_69()) {
    jj_scanpos = xsp;
    if (jj_3R_70()) {
    jj_scanpos = xsp;
    if (jj_3R_71()) {
    jj_scanpos = xsp;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_12() {
    if (jj_3R_43()) return true;
    return false;
  }

  private boolean jj_3R_46() {
    if (jj_3R_67()) return true;
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  private boolean jj_3R_20() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) return true;
    }
    return false;
  }

  private boolean jj_3R_49() {
    if (jj_3R_42()) return true;
    return false;
  }

  private boolean jj_3R_48() {
    if (jj_3R_43()) return true;
    return false;
  }

  private boolean jj_3_3() {
    if (jj_3R_21()) return true;
    return false;
  }

  private boolean jj_3R_31() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_48()) {
    jj_scanpos = xsp;
    if (jj_3R_49()) return true;
    }
    return false;
  }

  private boolean jj_3R_95() {
    if (jj_3R_122()) return true;
    return false;
  }

  private boolean jj_3R_94() {
    if (jj_3R_121()) return true;
    return false;
  }

  private boolean jj_3R_93() {
    if (jj_3R_120()) return true;
    return false;
  }

  private boolean jj_3R_92() {
    if (jj_3R_119()) return true;
    return false;
  }

  private boolean jj_3R_91() {
    if (jj_3R_118()) return true;
    return false;
  }

  private boolean jj_3_11() {
    if (jj_scan_token(DOT)) return true;
    if (jj_3R_42()) return true;
    return false;
  }

  private boolean jj_3R_90() {
    if (jj_3R_21()) return true;
    return false;
  }

  private boolean jj_3R_67() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_90()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) {
    jj_scanpos = xsp;
    if (jj_3R_95()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3_10() {
    if (jj_3R_41()) return true;
    return false;
  }

  private boolean jj_3R_65() {
    if (jj_3R_89()) return true;
    return false;
  }

  private boolean jj_3R_64() {
    if (jj_3R_88()) return true;
    return false;
  }

  private boolean jj_3_9() {
    if (jj_3R_40()) return true;
    return false;
  }

  private boolean jj_3R_63() {
    if (jj_3R_87()) return true;
    return false;
  }

  private boolean jj_3R_62() {
    if (jj_3R_86()) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_3R_39()) return true;
    return false;
  }

  private boolean jj_3R_61() {
    if (jj_3R_85()) return true;
    return false;
  }

  private boolean jj_3R_60() {
    if (jj_3R_84()) return true;
    return false;
  }

  private boolean jj_3R_59() {
    if (jj_3R_83()) return true;
    return false;
  }

  private boolean jj_3R_58() {
    if (jj_3R_82()) return true;
    return false;
  }

  private boolean jj_3R_57() {
    if (jj_3R_41()) return true;
    return false;
  }

  private boolean jj_3R_56() {
    if (jj_3R_40()) return true;
    return false;
  }

  private boolean jj_3R_123() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_3R_31()) return true;
    if (jj_scan_token(RBRACKET)) return true;
    return false;
  }

  private boolean jj_3R_172() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_3R_31()) return true;
    return false;
  }

  private boolean jj_3R_55() {
    if (jj_3R_39()) return true;
    return false;
  }

  private boolean jj_3R_42() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) {
    jj_scanpos = xsp;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) {
    jj_scanpos = xsp;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) {
    jj_scanpos = xsp;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_3R_65()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3_11()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_122() {
    if (jj_scan_token(ASM)) return true;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_scan_token(STRING_LITERAL)) return true;
    Token xsp;
    if (jj_3R_172()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_172()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(RPAREN)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public ColaTokenManager token_source;
  JavaCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[74];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static private int[] jj_la1_3;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
      jj_la1_init_3();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x0,0x0,0x0,0x18000,0x18000,0x7000,0x7000,0x0,0x0,0xe0000,0xe0000,0x0,0x0,0x0,0x0,0x0,0x60000,0x0,0x0,0x0,0x0,0x0,0xffbe0000,0x0,0x0,0x180000,0x0,0x0,0xf39e0000,0xc3060000,0xf39e0000,0x30000000,0x0,0xf39e0000,0xc200000,0xffbe0000,0x60000,0x0,0xc3060000,0x0,0x0,0x0,0x0,0x3000000,0x3000000,0x0,0x0,0x0,0x0,0x0,0x0,0xc3060000,0x0,0xc3060000,0x0,0x0,0x0,0xc3060000,0xc3060000,0x0,0x0,0xc3060000,0x0,0x0,0x0,0x0,0x60000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x1c00,0x1c00,0x80,0x0,0x0,0x0,0x0,0x0,0x80000000,0x7c00,0x7c00,0x0,0x40000,0x0,0x2000,0x4000,0x0,0x0,0x80000000,0xfffa8000,0x0,0x0,0x80000317,0x20,0x40,0x0,0x0,0x0,0x80000303,0x80000302,0x80000303,0x0,0x0,0x80000303,0x14,0x80000317,0x0,0x0,0x80000302,0x0,0x0,0xfffa8000,0x0,0x0,0x300,0x0,0x0,0x0,0x0,0x0,0x0,0x80000302,0x0,0x80000302,0x0,0x80000000,0x80000000,0x80000302,0x80000302,0x0,0x0,0x80000302,0x0,0xfffa8000,0x0,0x20000,0x7c00,0xfffa8000,0x188000,0x188000,0xffe20000,0x7fe00000,0x2000,0x0,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40,0x0,0x0,0x0,0x40,0x0,0x400,0x0,0x0,0x0,0x2000000,0x0,0x2000002,0x100,0x2,0x22011802,0x0,0x0,0x0,0x100,0x400,0x22011800,0x22011800,0x22011800,0x0,0x40,0x22011800,0x2,0x22011802,0x0,0x40,0x22011800,0x8,0x2000000,0x2000002,0x100,0x0,0x20000000,0x0,0x11800,0x80e000,0x1001800,0x7e0000,0x40,0x22011800,0x40,0x22011800,0x8,0x8,0x8,0x22011800,0x22011800,0x8,0x40,0x22011800,0x40,0x2000002,0x2000000,0x0,0x0,0x2000002,0x0,0x0,0x2000002,0x0,0x0,0x80,};
   }
   private static void jj_la1_init_3() {
      jj_la1_3 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x184,0x0,0x0,0x0,0x0,0x0,0x184,0x184,0x184,0x0,0x0,0x184,0x0,0x184,0x0,0x0,0x184,0x0,0x0,0x0,0x0,0x0,0x184,0x600,0x0,0x0,0x800,0x0,0x0,0x184,0x0,0x184,0x0,0x0,0x0,0x184,0x184,0x0,0x0,0x184,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[14];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public Cola(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public Cola(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new JavaCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ColaTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 74; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 74; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public Cola(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new ColaTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 74; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 74; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public Cola(ColaTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 74; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(ColaTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 74; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        exists = true;
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.add(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[108];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 74; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 108; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 14; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
