/*
 * COSMA -- A Virtual Machine for the Secure Cooperation of Untrusted Components.
 * Copyright (C) 2019  Roland Wismüller and Damian Ludwig, University of Siegen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package cola.util;

import java.io.FileInputStream;
import java.io.IOException;

public abstract class FileUtils {
    /**
     * Reads from given file and returns the content as a single string.
     *
     * @param filename the file to read
     * @return file content as string
     */
    public static String read(String filename) throws IOException {
        FileInputStream fis = new FileInputStream(filename);
        StringBuilder sb = new StringBuilder();
        int c;
        while ((c = fis.read()) != -1) {
            sb.append((char) c);
        }
        return sb.toString();
    }
}
